%define name WineX
%define lname wine

%def_disable oldrpm
%if_disabled oldrpm
%add_findprov_lib_path %_libdir/%lname
%set_verify_elf_method textrel=relaxed
%endif

Name: %name
Version: 3.2
Release: alt1.20031122
Serial: 5

Summary: MS-Windows with DirectX emulator
License: AFPL
Group: Emulators
URL: http://www.transgaming.com/

Source: %name.tar.bz2
Source1: %name-config.pl
Source2: %name-launcher.sh
Source3: %name.init
Source4: %name.HKLM
Source5: %name-startgame.sh
Source6: %name-README.ALT

Patch: %name-alt-config.patch
Patch1: %name-alt-fixes.patch
Patch2: %name-ogl.patch
Patch3: %name-%lname-20011226-debian.patch

PreReq: sed, awk, grep, shadow-utils
BuildPreReq: kernel-headers
Conflicts: wine

# Automatically added by buildreq on Fri Nov 28 2003
BuildRequires: XFree86-devel XFree86-libs flex freetype2-devel libGLU-devel libcups libjpeg-devel libssl-devel zlib-devel

%description
Wine, the Windows emulator, allows running Windows 3.*, Windows 95/98 and
Windows NT programs on a i386 (or compatible) machine running X11.

TransGaming WineX adds more complete implementations of the Microsoft (R) 
DirectX7 (R) APIs to the Wine project.  WineX is still in development,
but when complete is expected to allow almost any off-the-shelf DirectX-based
game to run under Wine.

It is still alpha level code; don't expect everything to work. Please read the
README.ALT in the docs directory for implementation details.

%package devel
Summary: MS-Windows emulator - Devel files
Group: Emulators
Requires: %name = %serial:%version-%release

%description devel
Wine, the Windows emulator, allows running Windows 3.*, Windows 95/98/ME and
Windows NT programs on a i386 (or compatible) machine running X11.

TransGaming WineX adds more complete implementations of the Microsoft (R) 
DirectX (R) APIs to the Wine project.  WineX is still in development,
but when complete is expected to allow almost any off-the-shelf DirectX-based
game to run under Wine.

This package provides the necessary development libraries and include files
to allow you to develop programs using WineX environment. You do not need this 
for apps startup debugging. This package also contains Wine/WineX documentation.

%package utils
Summary: MS-Windows emulator - Utilities
Group: Emulators
Requires: %name = %serial:%version-%release

%description utils
Wine, the Windows emulator, allows running Windows 3.*, Windows 95/98/ME and
Windows NT programs on a i386 (or compatible) machine running X11.

TransGaming WineX adds more complete implementations of the Microsoft (R) 
DirectX (R) APIs to the Wine project.  WineX is still in development,
but when complete is expected to allow almost any off-the-shelf DirectX-based
game to run under Wine.

This package consists many of the utilities provided by wine. This package is
not strictly necessary, and used mostly for testing wine functionality.

%prep
%setup -c -q
pushd %lname
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
popd %lname

%build
pushd %lname
%configure \
	--libdir=%_libdir/%lname \
	--includedir=%_includedir/%lname \
	--with-x \
	--enable-opengl
%make_build depend
%make_build
%make_build -C programs
popd %lname

%install
pushd %lname
%makeinstall \
	libdir=%buildroot%_libdir/%lname \
	includedir=%buildroot%_includedir/%lname \
	LDCONFIG=:
%makeinstall -C programs\
	bindir=%buildroot%_libdir/%lname \
	libdir=%buildroot%_libdir/%lname \
	includedir=%buildroot%_includedir/%lname \
	LDCONFIG=:

%__mkdir_p %buildroot%_sysconfdir
for i in system Desktop Favorites Fonts NetHood "Start Menu/Programs/Startup" \
        Recent SendTo ShellNew system32 Profiles/Administrator; do
	%__mkdir_p "%buildroot%_localstatedir/%lname/windows/$i"
done
%__mkdir_p "%buildroot%_localstatedir/%lname/Program Files/Common Files"
%__mkdir_p "%buildroot%_localstatedir/%lname/My Documents"
%__mkdir_p "%buildroot%_localstatedir/%lname/Temp"

for i in shell.dll shell32.dll winsock.dll wnsock32.dll opengl32.dll; do
	touch %buildroot%_localstatedir/%lname/windows/system32/$i
done
touch %buildroot%_localstatedir/%lname/autoexec.bat
touch %buildroot%_localstatedir/%lname/config.sys
touch %buildroot%_localstatedir/%lname/windows/win.ini
%__install -pD -m644 ./documentation/samples/system.ini \
	%buildroot%_localstatedir/%lname/windows/system.ini

%__mv %buildroot%_bindir/%lname %buildroot%_bindir/%{lname}real
%__install -p -m755 %SOURCE2 %buildroot%_bindir/%lname
%__install -p -m755 %SOURCE5 %buildroot%_bindir/startgame
%__install -pD -m644 ./documentation/samples/config %buildroot%_datadir/%lname/%lname.config.default
%__install -pD -m755 %SOURCE1 %buildroot%_datadir/%lname/%lname-config

# Install default HKLM registry
%__install -pD -m644 %SOURCE4 %buildroot%_sysconfdir/%lname.systemreg

# Make menu for utils
%__mkdir_p %buildroot%_menudir
%__cat <<__EOF >%buildroot%_menudir/%name
?package(%name): needs=x11 section="Emulators" title="%name" icon="applications_section.png"
?package(%name): needs=x11 section="Emulators/%name" title="Clock" \
	icon="toys_section.png" command="%_libdir/%lname/clock"
?package(%name): needs=x11 section="Emulators/%name" title="ComDlg Test" \
	icon="amusement_section.png" command="%_libdir/%lname/cmdlgtst"
?package(%name): needs=x11 section="Emulators/%name" title="Notepad" \
	icon="toys_section.png" command="%_libdir/%lname/notepad"
?package(%name): needs=x11 section="Emulators/%name" title="ProgManager" \
	icon="amusement_section.png" command="%_libdir/%lname/progman"
?package(%name): needs=x11 section="Emulators/%name" title="WMF View" \
	icon="toys_section.png" command="%_libdir/%lname/view"
?package(%name): needs=x11 section="Emulators/%name" title="WineMine" \
	icon="toys_section.png" command="%_libdir/%lname/winemine"
?package(%name): needs=x11 section="Emulators/%name" title="Winever" \
	icon="amusement_section.png" command="%_libdir/%lname/winver"
__EOF

# Relink utils
for i in `find %buildroot%_libdir -lname %lname -print0|xargs -r0`; do 
	%__rm -f $i && %__ln_s %_bindir/%{lname}real $i;
done

# Move some useful stuff from lib/wine to bin
%__mv %buildroot%_libdir/%lname/regapi* %buildroot%_bindir
%__mv %buildroot%_libdir/%lname/regsvr32* %buildroot%_bindir
%__mv %buildroot%_libdir/%lname/winedbg* %buildroot%_bindir
%__mv %buildroot%_libdir/%lname/wineconsole* %buildroot%_bindir

# Allow users to launch Windows programs by just clicking on the .exe file...
%__install -pD -m755 %SOURCE3 %buildroot%_initdir/%name

# Cleanup documentation
find %_builddir/%buildsubdir/%lname/documentation -type d -name CVS -print0|xargs -r0 rm -rf --
%__install -m 0644 %SOURCE6 README.ALT

%pre
/usr/sbin/groupadd -r -f %lname &>/dev/null

%post
%__grep -qs "^%_libdir/%lname$" %_sysconfdir/ld.so.conf || echo "%_libdir/%lname" >>%_sysconfdir/ld.so.conf
%post_ldconfig
%post_service %name

%preun
%preun_service %name

%postun
if [ "$1" = "0" ]; then
    %__rm -f %_sysconfdir/ld.so.conf.rpmtmp
    %__grep -F -v -e "%_x11libdir/%lname" -e "%_libdir/%lname" %_sysconfdir/ld.so.conf >%_sysconfdir/ld.so.conf.rpmtmp
    %__mv -f %_sysconfdir/ld.so.conf.rpmtmp %_sysconfdir/ld.so.conf || %__rm -f %_sysconfdir/ld.so.conf.rpmtmp
fi
%postun_ldconfig

%post utils
%update_menus

%postun utils
%clean_menus

%files
%doc %lname/{ANNOUNCE,AUTHORS*,BUGS,LICENSE*,README*,WARRANTY}
%config %_sysconfdir/*
%_bindir/wine
%_bindir/winereal
%_bindir/wine_relocated
%_bindir/wineclipsrv
%_bindir/regapi*
%_bindir/regsvr32*
%_bindir/wineconsole*
%_bindir/winedbg*
%_bindir/winedump
%_bindir/winelauncher
%_bindir/wineserver
%_bindir/wineshelllink
%_bindir/startgame
%dir %_libdir/%lname
%dir %_datadir/%lname
%_datadir/%lname/*
%_libdir/%lname/lib*
%_mandir/man?/*
%attr(755,root,%lname) %dir %_localstatedir/%lname
%defattr(-,root,%lname,775)
%_localstatedir/%lname/*

%files devel
%_bindir/fnt2bdf
%_bindir/function_grep.pl
%_bindir/widl
%_bindir/winemaker
%_bindir/winebuild
%_bindir/wmc
%_bindir/wrc
%_includedir/*
%_libdir/%lname/lib*.a
%doc %lname/documentation/*
%doc %lname/winedefault.reg
%doc %lname/DEVELOPERS-HINTS
%doc %lname/ChangeLog

%files utils
%_menudir/*
%_libdir/%lname/aviinfo*
%_libdir/%lname/aviplay*
%_libdir/%lname/clock*
%_libdir/%lname/cmdlgtst*
%_libdir/%lname/control*
%_libdir/%lname/icinfo*
%_libdir/%lname/notepad*
%_libdir/%lname/osversioncheck*
%_libdir/%lname/progman*
%_libdir/%lname/regtest*
%_libdir/%lname/uninstaller*
%_libdir/%lname/view*
#%_libdir/%lname/wcmd*
%_libdir/%lname/winemine*
%_libdir/%lname/winver*
#%_libdir/%lname/hlp2sgml
#%_libdir/%lname/winhelp*

%changelog
* Fri Nov 28 2003 Andy Gorev <horror@altlinux.ru> 5:3.2-alt1.20031122
- Last CVS snapshot with MAIN branch (winex-3-2)
- BuildRequires updated (huge simplifications)
- Documentation reworked, README.ALT added
- Small fixes in default alt-config & patches
- Opengl32 patched for best perfomance
- Root mapped as E: for system and debugger purposes
- Monotype fonts by default
- New default HKLM
- Rcdinit updated to the new rc scheme and renamed to WineX
- Devel and doc subpackages merged

* Fri Sep 05 2003 Andy Gorev <horror@altlinux.ru> 5:3.1-alt1.20030826
- Last CVS snapshot with MAIN branch (winex-3-1)
- kernel-headers BuildPreReq added
- Refix winedbg startup

* Sat Jun 14 2003 Andy Gorev <horror@altlinux.ru> 4:3.0-alt2.20030612
- Last CVS snapshot with winex-3-0-branch
- Spec: no more cleanups in install section
- BuildRequires updated
- Fix provides

* Sun Apr 06 2003 Andy Gorev <horror@altlinux.ru> 4:3.0-alt1.20030404
- Last CVS snapshot with MAIN branch (3-0-pre-1)
- Renamed with branch version
- Wcmd & winhelp removed from utils-subpackage due compile errors
- Default local machine registry updated
- Wineshelllink fix for menu creation
- Move utils to %_libdir for avoid conflicts
- BuildRequires updated

* Sun Mar 02 2003 Andy Gorev <horror@altlinux.ru> 3:2.2.1-alt4.20030217
- Last CVS snapshot with MAIN branch
- Alt-config patch revisited (some things merged upstream)
- Menu section changed to Emulators
- Icons in menu for utils-subpackage fixed

* Fri Jan 03 2003 Andy Gorev <horror@altlinux.ru> 3:2.2.1-alt3.20021113
- Wineshelllink simplification for menu
- New startgame script added for launch apps in separate X
- WineX.init stop-then-start fix
- DRI patch disabled due last X's "back to old DRI code"
- Cosmetic spec improvements

* Thu Dec 05 2002 Andy Gorev <horror@altlinux.ru> 2:2.2.1-alt2.20021113
- Fix winedbg startup in wineconsole
- Default local machine registry added

* Wed Dec 04 2002 Andy Gorev <horror@altlinux.ru> 1:2.2.1-alt1.20021113
- Last CVS snapshot with branch 2.2.1
- Renamed with branch version
- BuildRequires updated

* Mon Nov 25 2002 Andy Gorev <horror@altlinux.ru> 20021007-alt7
- All patches revisited
- Added some patches from ALTLinux's wine package
- Make & install winelib utils in utils-subpackage
- Regapi & regsvr32 added to main package
- Wineshelllink and menu support restored
- Support for workdir to startup script added
- Invoke auto-drive-mapper for users config disabled
- Old "before-alt" changelog stripped
- Some spec cleanup

* Fri Nov 08 2002 Andy Gorev <horror@altlinux.ru> 20021007-alt6
- Last CVS snapshot with branch 2.2 (cvs ... co -rwinex-2-2 wine)
- Patch for current XFree86 DRI's gl.h / glext.h headers

* Sun Oct 26 2002 Andy Gorev <horror@altlinux.ru> 20021007-alt5
- CVS snapshot 20021007
- BuildRequires updated
- Add winedefault.reg to doc package

* Wed Sep 25 2002 Andy Gorev <horror@altlinux.ru> 20020827-alt4
- BuildRequires updated

* Tue Sep 17 2002 Sir Raorn <raorn@altlinux.ru> 20020827-alt3
- BuildRequires updated
- Documentation is back again (now in -doc subpackage)

* Wed Sep 04 2002 Sir Raorn <raorn@altlinux.ru> 20020827-alt1
- CVS snapshot 20020827
- Spec cleanup
- Documentation temporary removed (openjade seems to be b0rken)

* Sat Jun 29 2002 Sir Raorn <raorn@altlinux.ru> 20020628-alt1
- CVS snapshot 20020628

* Thu May 16 2002 Sir Raorn <raorn@altlinux.ru> 20020515-alt1
- Built for Sisyphus

* Wed May 08 2002 Sir Raorn <raorn@altlinux.ru> 20020507-alt1raorn
- Initial release based on ALTLinux's wine package

* Tue Nov 20 2001 Dmitry V. Levin <ldv@alt-linux.org> 20011004-alt4
- Specfile cleanup.
- Rewritten startup script.
- Fixed typo in %{name}launcher.
- Added libwine_uuid.a to devel subpackage.

* Fri Oct 19 2001 AEN <aen@logic.ru> 20011004-alt3
- wineshelllink removed

* Wed Oct 17 2001 AEN <aen@logic.ru> 20011004-alt2
- wine group added in %pre

* Tue Oct 16 2001 AEN <aen@logic.ru> 20011004-alt1
- 20011004

* Tue Oct 16 2001 AEN <aen@logic.ru> 20010824-alt1
- 20010824

* Tue Sep 18 2001 AEN <aen@logic.ru> 20010731-alt2
- fixed documentation in package

* Tue Sep 18 2001 AEN <aen@logic.ru> 20010731-alt1
- alt1,2 patches
